//Hubl Config will take the config file and convert it to a hubL file
/**
	const {
		setHublConfigDest,
		setHublConfigVariableName,
		generateHublFromConfig
	} = require('hs-dev-helper/build/configToHubl');

	setHublConfigDest(path.join(__dirname, 'src/hubl/vars/config.html'))
	setHublConfigVariableName('myVar')
	generateHublFromConfig();

	-------

	Include the file at the top of your template
	{% import "./vars/config.html" %}
	
	-------
	
	Add Macro to add window variable
	{{ configToScript() }}
	Access in frontend JS by window.myVar

 */

const fs = require('fs');
const path = require('path'); 
const { getConfig } = require('../fieldsJs');

/**
 * Set Desctination path where the partial will be created
 */
let hublConfigDest = null
const setHublConfigDest = (path) => {
	hublConfigDest = path
	return hublConfigDest
}

let hublConfigVariableName = 'globalConfig'
const setHublConfigVariableName = (variable) => {
	hublConfigVariableName = variable
	return hublConfigVariableName
}

const generateHublFromConfig = (customConfig = null) => { 
	if (!hublConfigVariableName || !hublConfigDest) { return null }

	let data = `{# Automatically Generated #}\n`
	data += `{% set ${hublConfigVariableName} = ('${JSON.stringify(customConfig || getConfig())}')|fromjson %}`
	data += `\n\n{% macro configToScript() -%}<script type="text/javascript">window.${hublConfigVariableName} = JSON.parse('{{ ${hublConfigVariableName}|tojson|escapejson }}');</script>{%- endmacro %}`
	
	// Write
	fs.writeFileSync(path.resolve(hublConfigDest), data);
}

/**
 * Exports
 */
module.exports = {
	setHublConfigDest,
	setHublConfigVariableName,
	generateHublFromConfig
}