const { Field, config } = require('../index');

module.exports = class extends Field {
	
	constructor() {
		super()
		this.set('type',Field.choice().data.type)
			.name('padding', 'Padding')
			.choices(config('spacing'))
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}