const hexToRgb = (hex) => {
	// Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
	var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
	hex = hex.replace(shorthandRegex, function(m, r, g, b) {
		return r + r + g + g + b + b;
	});
	var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
	return result ? {
		r: parseInt(result[1], 16),
		g: parseInt(result[2], 16),
		b: parseInt(result[3], 16)
	} : null;
}

const rgbToHex =  (r, g, b) => {
	return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
}

const hsColurToRgb = ({ color, opacity = 100 }) => {
	let rgbObj = hexToRgb(color)
	return 'rgba(' + Object.values(rgbObj).join(',') +((opacity || 100)/100)+')';
}

exports.hexToRgb = hexToRgb
exports.rgbToHex = rgbToHex
exports.hsColurToRgb = hsColurToRgb

module.exports = {
	hexToRgb,
	rgbToHex,
	hsColurToRgb
}