const getQuery = (variable = null) => {
	const urlSearchParams = new URLSearchParams(window.location.search);
	const params = Object.fromEntries(urlSearchParams.entries());
	if (variable !== null) {
		return params[variable]
	}
	return params
}

const replaceQueryArgs = (data = {}) => { 
	addQueryArgs(data,true)
}

const addQueryArgs =  (data = {}) => { 
	let parsedUrl = new URL(window.location.href);
	const currentParams = Object.fromEntries(new URLSearchParams(parsedUrl.search).entries())
	parsedUrl.search = new URLSearchParams(Object.assign(currentParams,data));
	window.history.replaceState({}, "", parsedUrl.toString());
}

const removeQueryArgs = (keys) => { 
	keys = Array.isArray(keys) ? keys : [keys]
	let parsedUrl = new URL(window.location.href);
	const currentParams = Object.fromEntries(new URLSearchParams(parsedUrl.search).entries())
	keys.forEach(key => { delete currentParams[key]; });
	parsedUrl.search = new URLSearchParams(currentParams);
	window.history.replaceState({}, "", parsedUrl.toString());
}

const clearQueryArgs = () => { 
	this.addQueryArgs({},true)
}

exports.getQuery = getQuery
exports.replaceQueryArgs = replaceQueryArgs
exports.addQueryArgs = addQueryArgs
exports.removeQueryArgs = removeQueryArgs
exports.clearQueryArgs = clearQueryArgs

module.exports = {
	getQuery,
	replaceQueryArgs,
	addQueryArgs,
	removeQueryArgs,
	clearQueryArgs
}