// Capitalise first letter
const ucfirst = (str) => {
	return str.charAt(0).toUpperCase() + str.slice(1);
};

// Limit String
const limitLength = (string, limit) => {
	if (!string || !limit) { return; }
	return (limit - string.length) + '/' + limit + ' characters remaining';
};

// Limit String
const underLimit = (string, limit = 0) => {
	if (!string) { return false; }
	return string.length > limit;
};

//
const pluralise = (count = 0, plural = '', singular = '') => {
	count = parseFloat(count) || 0;
	var use = singular;
	if ([1, -1].indexOf(count) < 0) { use = plural; }
	return count + ' ' + use;
};

const slugify = (text) => {
	return text
		.toString()                           // Cast to string (optional)
		.normalize('NFKD')            // The normalize() using NFKD method returns the Unicode Normalization Form of a given string.
		.toLowerCase()                  // Convert the string to lowercase letters
		.trim()                                  // Remove whitespace from both sides of a string (optional)
		.replace(/\s+/g, '-')            // Replace spaces with -
		.replace(/[^\w\-]+/g, '')     // Remove all non-word chars
		.replace(/\-\-+/g, '-');        // Replace multiple - with single -
}

exports.ucfirst = ucfirst
exports.limitLength = limitLength
exports.underLimit = underLimit
exports.pluralise = pluralise

module.exports = {
	ucfirst,
	limitLength,
	underLimit,
	pluralise,
	slugify
}